<template>
	<el-drawer title="知识关键词" v-model="drawerVisible" size="40%">
		<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
			<el-form-item label="关键词" prop="Tag">
				<el-input v-model="state.queryParams.Tag" placeholder="请输入关键词" clearable @keyup.enter="queryList" />
			</el-form-item>
			<el-form-item>
				<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(ruleFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
			</el-form-item>
		</el-form>
    <ProTable
      ref="proTableRef"
      :columns="columns"
      :data="state.tableData"
      @updateTable="queryList"
      :loading="state.loading"
      :total="state.total"
      v-model:page-index="state.queryParams.PageIndex"
      v-model:page-size="state.queryParams.PageSize"
    >
      <!-- 表格 header 按钮 -->
      <template #tableHeader="scope">
        <el-button type="primary" @click="addParameter"> <SvgIcon name="ele-Plus" class="mr5" />新增 </el-button>
        <el-button type="primary" @click="businessTagRemove" :disabled="!scope.isSelected">
          <SvgIcon name="ele-Delete" class="mr5" />删除
        </el-button>
      </template>
      <!-- 表格操作 -->
      <template #operation="{ row }">
        <el-button link type="primary" @click="updateLexicon(row)" title="编辑知识库词库"> 编辑 </el-button>
      </template>
    </ProTable>

		<template #footer>
			<span class="dialog-footer">
				<el-button @click="drawerVisible = false" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onConfirm" :loading="state.loading">提 交</el-button>
			</span>
		</template>
	</el-drawer>
	<!--  新增知识库词库  -->
	<knowledge-lexicon-add ref="knowledgeLexiconAddRef" @updateList="queryList" :knowledgeWordClassify="knowledgeWordClassify" />
	<!--  编辑知识库词库  -->
	<knowledge-lexicon-edit ref="knowledgeLexiconEditRef" @updateList="queryList" :knowledgeWordClassify="knowledgeWordClassify" />
</template>
<script setup lang="tsx">
import { defineAsyncComponent, reactive, ref } from 'vue';
import { knowledgeLexiconDelete, knowledgeLexiconList, orderKnowledgeBaseData } from '@/api/auxiliary/knowledgeLexicon';
import { ElButton, ElMessage, ElMessageBox, FormInstance } from "element-plus";
import { formatDate } from "@/utils/formatTime";

const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
  { type: 'selection', fixed: 'left', width: 55 },
  { prop: 'tag', label: '关键词'},
  { prop: 'synonym', label: '同义词' },
  { prop: 'operation', label: '操作', fixed: 'right', width: 100, align: 'center' },
]);
// 引入组件
const KnowledgeLexiconAdd = defineAsyncComponent(() => import('@/views/auxiliary/knowledgeLexicon/components/Knowledge-lexicon-add.vue')); // 新增知识库词库
const KnowledgeLexiconEdit = defineAsyncComponent(() => import('@/views/auxiliary/knowledgeLexicon/components/Knowledge-lexicon-edit.vue')); // 编辑知识库词库

const emit = defineEmits(['selectKeyword']);

const drawerVisible = ref<boolean>(false);

const state = reactive({
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 10,
		Tag: null, // 标签
		Classify: null, // 标签类型
		Synonym: null, // 近义词
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<any>(null); // 表单ref
const knowledgeWordClassify = ref<EmptyArrayType>(); // 标签类型
const keywordIds = ref<EmptyArrayType>(); // 关键词ID
// 获取基础数据
const getBaseData = async () => {
	try {
		const res = await orderKnowledgeBaseData();
		knowledgeWordClassify.value = res.result?.knowledgeWordClassify ?? [];
	} catch (error) {
		console.log(error);
	}
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	knowledgeLexiconList(state.queryParams)
		.then((res) => {
			state.loading = false;
			state.tableData = res.result.items ?? [];
			state.total = res.result.total ?? 0;
      proTableRef.value.clearSelection();
			if (keywordIds.value && keywordIds.value.length) {
				for (let i of keywordIds.value) {
					for (let j of state.tableData) {
						if (i === j.id) {
							setTimeout(() => {
                proTableRef.value!.element.toggleRowSelection(j, true);
							}, 0);
						}
					}
				}
			} else {
        proTableRef.value.clearSelection();
			}
		})
		.finally(() => {
			state.loading = false;
		});
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增词库
const knowledgeLexiconAddRef = ref<RefType>();
const addParameter = () => {
	knowledgeLexiconAddRef.value.openDialog();
};
// 编辑知识库词库
const knowledgeLexiconEditRef = ref<RefType>();
const updateLexicon = (row: any) => {
	knowledgeLexiconEditRef.value.openDialog(row.id);
};
// 删除词库
const businessTagRemove = () => {
	const ids = proTableRef.value.selectedList.map((item: any) => item.id);
	const names = proTableRef.value.selectedList.map((item: any) => item.tag);
	ElMessageBox.confirm(`您确定要删除：【${names}】，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			knowledgeLexiconDelete({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
// 确定选择关键词
const onConfirm = () => {
	const ids = proTableRef.value.selectedList.map((item: any) => item.id);
	const name = proTableRef.value.selectedList.map((item: any) => item.tag).join(',');
	emit('selectKeyword', { ids, name });
	drawerVisible.value = false;
};
// 打开弹窗
const openDialog = (keywords: any[]) => {
	keywordIds.value = keywords;
	getBaseData();
	queryList();
	drawerVisible.value = true;
};
// 关闭弹窗
const closeDialog = () => {
	drawerVisible.value = false;
};
defineExpose({
	openDialog,
	closeDialog,
});
</script>
